/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vehicle;

import static a_program.Program.assetManager;
import static a_program.Program.vrPerson;
import a_program.VrPerson;
import com.jme3.asset.AssetManager;
import com.jme3.material.Material;
import com.jme3.math.Vector3f;
import com.jme3.scene.Node;
import com.jme3.scene.shape.Box;
import e_tco.Action3dElement;
import e_tco.GeometryAction;

/**
 *
 * @author Eirik
 */
public class Guardrail implements Action3dElement {

    Vehicle vehicle;
    Node rail;

    public Guardrail(Vehicle vehicle, Node rail) {
        this.vehicle = vehicle;
        this.rail = rail;

        Material matDebug = new Material(assetManager, "Common/MatDefs/Misc/ShowNormals.j3md");

        float x = 1.5f;
        float y = 0.4f;
        float z = .4f;

        Box cube1Mesh = new Box(0.05f, 0.5f, 0.05f);
        GeometryAction railGeo1 = new GeometryAction("GuardrailGrip", cube1Mesh, this);
        railGeo1.setMaterial(matDebug);
        rail.attachChild(railGeo1);
        railGeo1.setLocalTranslation(x, y, z);

        Box cube2Mesh = cube1Mesh.clone();
        GeometryAction railGeo2 = new GeometryAction("GuardrailGrip", cube2Mesh, this);
        railGeo2.setMaterial(matDebug);
        rail.attachChild(railGeo2);
        railGeo2.setLocalTranslation(-x, y, z);

        Box cube3Mesh = cube1Mesh.clone();
        GeometryAction railGeo3 = new GeometryAction("GuardrailGrip", cube3Mesh, this);
        railGeo3.setMaterial(matDebug);
        rail.attachChild(railGeo3);
        railGeo3.setLocalTranslation(x, y, -z);

        Box cube4Mesh = cube1Mesh.clone();
        GeometryAction railGeo4 = new GeometryAction("GuardrailGrip", cube4Mesh, this);
        railGeo4.setMaterial(matDebug);
        rail.attachChild(railGeo4);
        railGeo4.setLocalTranslation(-x, y, -z);

        Box cube5Mesh = new Box(0.5f, 0.05f, 0.05f);
        GeometryAction railGeo5 = new GeometryAction("GuardrailGrip", cube5Mesh, this);
        railGeo5.setMaterial(matDebug);
        rail.attachChild(railGeo5);
        railGeo5.setLocalTranslation(0, y + .7f, z);
    }
    
    public Vehicle getVehicle()
    {
        return vehicle;
    }

    public Vector3f getGuardrailPos() {
        return rail.getWorldTranslation();
    }

    @Override
    public void click() {
        vrPerson.board(this);
    }
}
