/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package vehicle;

import a_program.Program;
import static a_program.Program.assetManager;
import a_program.StartParameters;
import c_trackNode.TrackNode;
import com.jme3.asset.AssetManager;
import com.jme3.audio.AudioNode;
import com.jme3.bullet.BulletAppState;
import com.jme3.material.Material;
import com.jme3.math.ColorRGBA;
import com.jme3.math.FastMath;
import com.jme3.math.Quaternion;
import com.jme3.math.Vector3f;
import com.jme3.scene.Geometry;
import com.jme3.scene.Node;
import com.jme3.scene.Spatial;
import com.jme3.scene.shape.Box;
import f_general.MyAudioNode;
import m_ertms_dmi_subclasses.DMIFrame;
import m_ertms_onboard.ActivateCabSwitch;
import m_ertms_onboard.AtcSwitch;
import m_ertms_onboard.DMI;
import m_ertms_onboard.ETCS;
import m_ertms_onboard.Rack;
import m_ertms_onboard.RackFrame;
import m_ertms_onboard.SpeedSensor;
import m_ertms_tco.ErtmsStopp;
import m_ertms_tco.EuroBalise;
import m_stm_model_model.StmModel;
import m_stm_model_model.StmModelFrame;
import n_no_tco.Balise;
import e_tco.TrackConnectedObject;
import e_tco.UpdateObject;
import java.awt.Color;
import java.text.DecimalFormat;
import m_ertms_tco.ErtmsLevelAncmnt;
import m_ertms_tco.ErtmsLevelMode;
import m_stm_model_model.AtcPanelFrame;
import m_stm_model_panel.AtcPanel;
import vehicle_ertms_equipped.DMIVehicle;
import vehicle_traction_brake_system.BrakeFrame;
import vehicle_traction_brake_system.BrakePerformanceFrame;
import vehicle_traction_brake_system.HlPressureFrame;
import vehicle_traction_brake_system.SpeedomFrame;
import vehicle_traction_brake_system.TractionFrame;
import vehicle_traction_brake_system.TractionBrakeControl;
import vehicle_traction_brake_system.VRShuntingTrainControlFrame;

/**
 *
 * @author hallgeo
 */
public class SimSimpleVehicle extends Vehicle implements UpdateObject, DMIVehicle {
    // updatecounter

    int uc = 0;

    // ETCS / STM UTRUSTNING
    private Rack rack;
    private ETCS etcs;
    private RackFrame rackFrame = new RackFrame("", this);
    private SpeedSensor speedSensor = new SpeedSensor();
    private boolean showRack = false; //true;

    private DMIFrame dmiFrame;
    private DMI dmi, dmi1, dmi2;

    // Traction brake
    protected TractionBrakeControl tractionBrakeControl = new TractionBrakeControl();
    private TractionFrame tractionFrame = new TractionFrame(tractionBrakeControl);
    private BrakeFrame brakeFrame = new BrakeFrame();
    private BrakePerformanceFrame brakePerformanceFrame;
    // vr
    private VRShuntingTrainControlFrame vrSimpleTCFrame = new VRShuntingTrainControlFrame();

    // speedom
    private SpeedomFrame speedomFrame = new SpeedomFrame();

    // hl
    private HlPressureFrame hlPressureFrame = new HlPressureFrame();

    // speedchanges
    private int intSpeedKmh = 0;
    private int intSpeedKmhPrev = 0;
    private boolean speedChange = false;
    protected boolean speedChangeForSubClass = false;

    // audio
    private boolean loopingSoundStartStop = false;
    private boolean nonLoopingSoundStart = false;
    private MyAudioNode audio1;
    private MyAudioNode audio2;
    private MyAudioNode audio3;
    private MyAudioNode audio4;
    private MyAudioNode audioNode_atc_kort;
    private MyAudioNode audioNode_atc_2korte;
    private MyAudioNode audioNode_atc_lang;
    private MyAudioNode audioNode_atc_overhast;
    private MyAudioNode audioNode_atc_atcfeil;
    private MyAudioNode audioNode_atc_startup;
    private MyAudioNode audioNode_atc_balisefeil;
    private MyAudioNode audioNode_ertms_info;
    private MyAudioNode audioNode_ertms_click;
    private MyAudioNode audioNode_ertms_tooFast;
    private MyAudioNode audioNode_ertms_warning;
    private MyAudioNode audioNode_ertms_cont;
    private boolean playSwitchSound1 = false;
    private boolean playSwitchSound2 = false;
    private boolean playAtcKortSound = false;
    private boolean playAtc2KorteSound = false;
    private boolean playAtcLangSound = false;
    private boolean playAtcBalisefeilSound = false;
    private boolean startAtcOverhastSound = false;
    private boolean stopAtcOverhastSound = false;
    private boolean startAtcAtcfeilSound = false;
    private boolean stopAtcAtcfeilSound = false;
    private boolean startAtcStartUpSound = false;
    private boolean stopAtcStartUpSound = false;
    private boolean playErtmsInfoSound = false;
    private boolean playErtmsClickSound = false;
    private boolean playErtmsTooFastSound = false;
    private boolean startErtmsWarningSound = false;
    private boolean stopErtmsWarningSound = false;
    private boolean startErtmsContSound = false;
    private boolean stopErtmsContSound = false;
    private static final float ATC_SOUNDS_VOLUME = StartParameters.atcSoundsVolume;

    // cab number
    private int activeCabNr = 2;

    // simulated train length - forflytning ved endebytte
    private float simulatedTrainLength = 100;
    private boolean moveVehicleCabChange = false;
    private float moveVehicleOdom = 0;

    // kontrollert spoling
    protected boolean controlledSpolingOn = false;
    public final static float CONTROLLED_SPOLINGSPEED_KMH = 400;
    public final static float CONTROLLED_SPOLING_REVERSE_SPEED_KMH = -40;

    // vr model
    private AtcPanel atcPanel;
    private AtcPanelFrame atcPanelFrame;
    private VrAtcPanel vrAtc;
    private boolean vrModelExists = false;
    //private Kobbel kobbelTog1;
    //private Kobbel kobbelTog2;
    private AirCoupling airTrain1;
    private AirCoupling airTrain2;
    private Coupling couplingTrain1;
    private Coupling couplingTrain2;

    // person
    private Vector3f personOffsetVector;
    private float personRotationGrad;

    public SimSimpleVehicle(String vehicleName) {
        super(vehicleName);
        initSim();

        // if VR
        if (Program.vrOn) {
            initVrModel();
            //initVrSimpleTrainControl(assetManager);
        }

        if (Program.loadDetailedComponents) {
            // startendkobbeltog
            //kobbelTog1 = kobbel1;
            //kobbelTog2 = kobbel2;
            couplingTrain1 = coupling1;
            couplingTrain2 = coupling2;
        }

        vrSimpleTCFrame.repaint();

        this.locomotive = true;
    }

    protected void initSim() {
        // connect components
        tractionBrakeControl.setFv(this);
        //tractionFrame.setTractionBrakeControl(tractionBrakeControl);
        tractionBrakeControl.setTractionFrame(tractionFrame);
        tractionBrakeControl.setSpeedomFrame(speedomFrame);
        brakeFrame.setTractionBrakeControl(tractionBrakeControl);
        tractionBrakeControl.setBrakeFrame(brakeFrame);
        tractionBrakeControl.setHlPressureFrame(hlPressureFrame);
        tractionFrame.setFv(this);
        tractionBrakeControl.initExternalInput();
        vrSimpleTCFrame.setTractionBrakeControl(tractionBrakeControl);
        tractionBrakeControl.setvRShuntingTrainControlFrame(vrSimpleTCFrame);

        // brake performance adjustment
        if (StartParameters.showBrakePerformanceAdjustment) {
            brakePerformanceFrame = new BrakePerformanceFrame();
            brakePerformanceFrame.setTbc(tractionBrakeControl);
            brakePerformanceFrame.initAll();
        }

        // ETCS / STM UTRUSTNING
        //rackFrame.setLocation(StartParameters.rackFrameLocX, StartParameters.rackFrameLocY/*800, 860*/);
        rackFrame.pack();

        // opprett Rack og ETCS
        rack = new Rack();
        etcs = new ETCS();
        etcs.setSimSimpleVehicle(this);
        rack.setETCS(etcs);
        etcs.setRack(rack);
        rack.setVehicle(this);

        // sett inn STM
        StmModelFrame a = new StmModelFrame();
        StmModel stmModel = a.getStmModel();
        atcPanel = stmModel.getAtcPanel();
        atcPanelFrame = stmModel.getAtcPanelFrame();

        stmModel.getAtcPanel().setSimVeh(this);
        stmModel.getAtcFault().setSimVeh(this);
        stmModel.getBf1().setSimVeh(this);
        stmModel.getBf2().setSimVeh(this);
        stmModel.getBf3().setSimVeh(this);
        stmModel.getSt().setSimVeh(this);

        stmModel.setEtcs(etcs);
        etcs.setStmModel(stmModel);

        rack.setStmModel(stmModel);
        stmModel.setRack(rack);

        speedSensor.setVehicle(this);
        rack.setSpeedSensor(speedSensor);

        // connect isolation and powerswitch
        rackFrame.getIsolationSwitch().setEtcs(etcs);
        rackFrame.getPowerSwitch().setEtcs(etcs);
        rackFrame.getEmBrakeSwitch().setEtcs(etcs);
        rackFrame.getS1Type75().setEtcs(etcs);

        etcs.setPowerSwitch(rackFrame.getPowerSwitch());
        etcs.setIsolationSwitch(rackFrame.getIsolationSwitch());

        rackFrame.getAtcSwitch().setStmModel(stmModel);
        stmModel.setAtcSwitch(rackFrame.getAtcSwitch());

        // connect brakemodule
        // to be implemented
        //((ETCSTrainBrakeModule)brakeModule).setEtcsMiddleCar(this);
        //
        rackFrame.setVisible(showRack);

        // dmi
        dmiFrame = new DMIFrame("");
        dmi = dmi1 = dmi2 = dmiFrame.getDMI();
        etcs.setDmi1(dmi1);
        etcs.setDmi2(dmi2);
        dmi.setEtcs(etcs);

        // dmi visible
        if (StartParameters.atcPanelVisible && !StartParameters.dmiVisible) {
            dmiFrame.setVisible(false);
        } else {
            speedomFrame.setVisible(false);
        }

        // TrackBuild
        if (Program.TRACK_BUILD_MODE) {
            tractionFrame.setVisible(false);
            dmiFrame.setVisible(false);
            brakeFrame.setVisible(false);
            hlPressureFrame.setVisible(false);
            rackFrame.setVisible(false);
        }

        // VR
        if (Program.vrOn) {
            tractionFrame.setVisible(false);
            dmiFrame.setVisible(false);
            brakeFrame.setVisible(false);
            hlPressureFrame.setVisible(false);
            rackFrame.setVisible(false);
            speedomFrame.setVisible(false);
            //stmModel.getAtcPanelFrame().setVisible(false);
        }

        // No VR Person
        if (Program.loadDetailedComponents) {
            tractionFrame.setVisible(false);
            dmiFrame.setVisible(false);
            brakeFrame.setVisible(false);
            hlPressureFrame.setVisible(false);
            rackFrame.setVisible(false);
            speedomFrame.setVisible(false);
            //stmModel.getAtcPanelFrame().setVisible(false);
        }

        if (!Program.TRACK_BUILD_MODE && !Program.vrOn && !Program.loadDetailedComponents) {
            vrSimpleTCFrame.setVisible(false);
        }
    }

    private Spak spakB;
    private Spak spakP;
    private VrInfoPanel vrInfoP;

    private void initVrModel() {
        // atcpanel
        vrAtc = new VrAtcPanel(assetManager);
        vrAtc.create();
        vrAtc.getPivot().setLocalTranslation(-0.7f, 1.1f, 11.3f);
        pivot.attachChild(vrAtc.getPivot());

        rack.getStmModel().getAtcPanel().getHoved().setvRIndikator(vrAtc.gethInd());
        rack.getStmModel().getAtcPanel().getForind().setvRIndikator(vrAtc.getfInd());

        // infopanel
        vrInfoP = new VrInfoPanel(assetManager, Color.magenta);
        vrInfoP.getPivot().setLocalTranslation(-0.7f, 0.9f, 11.3f);
        pivot.attachChild(vrInfoP.getPivot());

        // brems spak
        spakB = new Spak(assetManager);
        spakB.create();
        spakB.getBasePivot().setLocalTranslation(-1.2f, 1.0f, 10.7f);
        pivot.attachChild(spakB.getBasePivot());

        // pådrag spak
        spakP = new Spak(assetManager);
        spakP.create();
        spakP.getBasePivot().setLocalTranslation(-0.5f, 1.0f, 10.7f);
        pivot.attachChild(spakP.getBasePivot());

        //
        vrModelExists = true;
    }

//  private void initVrSimpleTrainControl(AssetManager assetManager)
//  {
//    
//  }
    public void openDriverEnvironmentFrames() {
        tractionFrame.setVisible(true);
        dmiFrame.setVisible(false);
        brakeFrame.setVisible(true);
        hlPressureFrame.setVisible(true);
        speedomFrame.setVisible(true);
        atcPanelFrame.setVisible(true);

        // foreløbig løysing for at kobbel ikkje skal visast frå førerrom når ein går inn i førerom frå NoVrPersonMode
        /*kobbel1.getBasePivot().setLocalTranslation(0, -0.5f, -10.0f);
    kobbel2.getBasePivot().setLocalTranslation(0, -0.5f, 10.0f);*/
    }

    public void closeDriverEnvironmentFrames() {
        tractionFrame.setVisible(false);
        dmiFrame.setVisible(false);
        brakeFrame.setVisible(false);
        hlPressureFrame.setVisible(false);
        speedomFrame.setVisible(false);
        atcPanelFrame.setVisible(false);

        // foreløbig løysing for at kobbel skal visast igjen frå utsida når ein går ut av førerom til NoVrPersonMode
        /*kobbel1.getBasePivot().setLocalTranslation(0, -0.5f, -12.4f);
    kobbel2.getBasePivot().setLocalTranslation(0, -0.5f, 12.4f);*/
    }

    Vector3f qVec = new Vector3f(1, 0, 0);
    Quaternion q1 = new Quaternion().fromAngleAxis(FastMath.DEG_TO_RAD * 0, qVec);
    Vector3f vecFor = new Vector3f();

    public void vrGripBrems(Vector3f vec) {
        spakB.vrGrip(vec);
    }

    public void vrGripPadr(Vector3f vec) {
        spakP.vrGrip(vec);
    }

    public void setKjVendF() {
        tractionBrakeControl.activateCabSwitchChange(ActivateCabSwitch.STATE_F);
    }

    public void setKjVendB() {
        tractionBrakeControl.activateCabSwitchChange(ActivateCabSwitch.STATE_B);
    }

    public TractionBrakeControl getTractionBrakeControl() {
        return tractionBrakeControl;
    }

    public void changeDriverCab() {
        System.out.println("bytt ende");
        if (activeCabNr == 2) {
            activeCabNr = 1;
        } else if (activeCabNr == 1) {
            activeCabNr = 2;
        }

        // flytt vehicle i forhold til simulert toglengde
        // flytting foregår i tick()
        if (activeCabNr == 2) {
            moveVehicleOdom = getOdometer() + (simulatedTrainLength - 2*vd.trainColliderLength);
        } else if (activeCabNr == 1) {
            moveVehicleOdom = getOdometer() - (simulatedTrainLength - 2*vd.trainColliderLength);
        }

        moveVehicleCabChange = true;
    }

    private void changeCamAndMove() {
        if (activeCabNr == 2) {
            changeToCamCab2();
        } else if (activeCabNr == 1) {
            changeToCamCab1();
        }
        setOdometer(moveVehicleOdom);
        moveVehicleCabChange = false;
    }

    private float ts = 0.0f;
    private float speedVolume = 0.01f;
    private float speedPitch = 0.01f;
    private float speedAlpha = 0.0f;

    @Override
    public void tick() {
        // change cab
        if (moveVehicleCabChange) // normally false - just one frame during cab change
        {
            changeCamAndMove();
        }

        super.tick();

        // Move brakes
        int i = 0;
        for (Spatial b : brakes) {
            i++;
            float offset = b.getLocalTranslation().z + ((brakeOffset * ((i % 2 == 0) ? 1 : -1)) * tractionBrakeControl.getAirBrake() - b.getLocalTranslation().z) * secsSinceLastFrame * 2.5f;
            b.setLocalTranslation(0, 0, offset);
        }

        //  Move brakes on connected vehicles
        for (int a = 0; a < 2; a++) {
            if (getAirCoupling(a).getOpen()) {
                AirCoupling c = getAirCoupling(a).getConnectedTo();
                while (c != null) {
                    if (!c.getOpen()) {
                        break;
                    }

                    c.getVehicle().setBrake(tractionBrakeControl.getAirBrake());

                    int j = 0;
                    for (Spatial b : c.getVehicle().brakes) {
                        j++;
                        float offset = b.getLocalTranslation().z + ((brakeOffset * ((j % 2 == 0) ? 1 : -1)) * tractionBrakeControl.getAirBrake() - b.getLocalTranslation().z) * secsSinceLastFrame * 2.5f;
                        b.setLocalTranslation(0, 0, offset);
                    }
                    c = c.getVehicle().getAirCoupling(a).getConnectedTo();
                }
            }
        }

        // audio
        if (!StartParameters.audioOn) {
            return;
        }

        sounds();
    }

    int count1 = 0;
    DecimalFormat df = new DecimalFormat("#.0");
    String hlS;

    @Override
    public void updateTickWhilePause() {
        soundsWhilePause();
    }

    @Override
    public void functionsUpdateCh1() {
        // VR
        if (vrModelExists) {
            vrAtc.tick();

            vrUpdateDrivingControls();

            if (count1 == 2) {
                // info panel - speed HL
                vrInfoP.setinfo(" " + ((int) tractionBrakeControl.getSpeedKmh()) + " km/t " + ((int) tractionBrakeControl.getTargetSpeedKmH()) + "  "
                        + df.format(tractionBrakeControl.getHLGauge()) + " bar");
                vrInfoP.tick();

                count1 = 0;

                // collision
                //checkCollisionWithOtherVehicles();
            }

            count1++;
        }
    }

//  public void checkCollisionWithOtherVehicles()
//  {
////    System.out.println("1: " + kobbelTog1.getBasePivot().getWorldTranslation());
////    System.out.println("2: " + kobbelTog2.getBasePivot().getWorldTranslation());
////    System.out.println("");
//  }
    public void updateStartEndKobbelTog() {
        /*System.out.println("oppdater startendkobbel");
    Vehicle veh = this;
    kobbelTog1 = kobbel1;
    while (veh != null)
    {
      kobbelTog1 = veh.getKobbel1();
      Kobbel k = kobbelTog1.getKobletTil();
      if (k != null)
      {
        veh = k.getVehicle();
      } else
      {
        veh = null;
      }
    }

    veh = this;
    kobbelTog2 = kobbel2;
    while (veh != null)
    {
      kobbelTog2 = veh.getKobbel2();
      Kobbel k = kobbelTog2.getKobletTil();
      if (k != null)
      {
        veh = k.getVehicle();
      } else
      {
        veh = null;
      }
    }*/
    }

    public void UpdateAirCouplings() {
        System.out.println("updating air couplings");
        Vehicle veh = this;
        airTrain1 = air1;
        while (veh != null) {
            airTrain1 = veh.getAirCoupling1();
            AirCoupling k = airTrain1.getConnectedTo();
            if (k != null) {
                veh = k.getVehicle();
            } else {
                veh = null;
            }
        }

        veh = this;
        airTrain2 = air2;
        while (veh != null) {
            airTrain2 = veh.getAirCoupling2();
            AirCoupling k = airTrain2.getConnectedTo();
            if (k != null) {
                veh = k.getVehicle();
            } else {
                veh = null;
            }
        }
    }

    public void UpdateCouplings() {
        System.out.println("updating couplings");
        Vehicle veh = this;
        couplingTrain1 = coupling1;
        while (veh != null) {
            couplingTrain1 = veh.getCoupling(0);
            Coupling c = couplingTrain1.getConnectedTo();
            if (c != null) {
                veh = c.getVehicle();
            } else {
                veh = null;
            }
        }

        veh = this;
        couplingTrain2 = coupling2;
        while (veh != null) {
            couplingTrain2 = veh.getCoupling(1);
            Coupling c = couplingTrain2.getConnectedTo();
            if (c != null) {
                veh = c.getVehicle();
            } else {
                veh = null;
            }
        }
    }

    private TrackNode kobbelCollRunner = null;
    private float kobbelColPos;
    private float kobbelColDist;

    public void checkKobbelCollision() {
        if (speedKmh < 0.5f) {
            return;
        }

        if (direction > 0) {
            checkKobbelCollision2();
        } else {
            checkKobbelCollision1();
        }
    }

    private void checkKobbelCollision1() {
        /*
    kobbelCollRunner = couplingTrain1.getVehicle().getTrackRunner1();
    kobbelColPos = kobbelCollRunner.getPos();
    
    kobbelCollRunner = kobbelCollRunner.forrige;
    kobbelColDist = kobbelColPos - kobbelCollRunner.getPos();
    
    while (kobbelColDist < 0.5f)
    {
      if (kobbelCollRunner.isTrackRunnerNode())
      {
        System.out.println("collsion 1");
        forceStopTrain();
        return;
      }
        kobbelCollRunner = kobbelCollRunner.forrige;
        kobbelColDist = kobbelColPos - kobbelCollRunner.getPos();
    }*/
        boolean differentTrain;
        for (Vehicle v : Program.stVehicleList) {
            differentTrain = true;
            if (v != couplingTrain1.getVehicle()) {
                Coupling c = couplingTrain1.getVehicle().getCoupling2().getConnectedTo();
                while (c != null) {
                    if (c.getVehicle() == v) {
                        differentTrain = false;
                    }
                    c = c.getVehicle().getCoupling2().getConnectedTo();
                }
                if (differentTrain) {
                    for (int i = 0; i < 2; i++) {
                        if (v.getCoupling(i).getBasePivot().getWorldTranslation().distance(couplingTrain1.getBasePivot().getWorldTranslation()) < 1) {
                            forceStopTrain();
                            return;
                        }
                    }
                }
            }
        }

//    System.out.println("ikke collission 1");
    }

    private void checkKobbelCollision2() {
        /*
    kobbelCollRunner = couplingTrain2.getVehicle().getTrackRunner2();
    kobbelColPos = kobbelCollRunner.getPos();
    
    kobbelCollRunner = kobbelCollRunner.neste;
    kobbelColDist = kobbelCollRunner.getPos() - kobbelColPos;
    
    while (kobbelColDist < 0.5f)
    {
      if (kobbelCollRunner.isTrackRunnerNode())
      {
        System.out.println("collsion 2");
        forceStopTrain();
        return;
      }
        kobbelCollRunner = kobbelCollRunner.neste;
        kobbelColDist = kobbelCollRunner.getPos()- kobbelColPos;
    }*/

        boolean differentTrain;
        for (Vehicle v : Program.stVehicleList) {
            differentTrain = true;
            if (v != couplingTrain2.getVehicle()) {
                Coupling c = couplingTrain2.getVehicle().getCoupling1().getConnectedTo();
                while (c != null) {
                    if (c.getVehicle() == v) {
                        differentTrain = false;
                    }
                    c = c.getVehicle().getCoupling1().getConnectedTo();
                }
                if (differentTrain) {
                    for (int i = 0; i < 2; i++) {
                        if (v.getCoupling(i).getBasePivot().getWorldTranslation().distance(couplingTrain2.getBasePivot().getWorldTranslation()) < 1) {
                            forceStopTrain();
                            return;
                        }
                    }
                }
            }
        }

//    System.out.println("ikke collission 2");
    }

    private void forceStopTrain() {
        tractionBrakeControl.forceSpeedZero();
    }

    private void vrUpdateDrivingControls() {
        if (!spakB.alphaHasChanged() && !spakP.alphaHasChanged()) {
            return;
        }

        tractionBrakeControl.setBrakeHandleAlphaFromExternInput(spakB.getAlpha());
        tractionBrakeControl.setTractionHandleAlpha(1 - spakP.getAlpha());
    }

    private static boolean staticPlayClick = false;

    private void sounds() {
        // continous sounds - ALWAYS
        // speed sound
        if (speedChange) {
            speedAlpha = Math.min((speedKmh / 160.0f), 1.0f);
            speedVolume = Math.min(speedAlpha, 0.65f);
            speedPitch = speedAlpha + 0.51f;
            audio2.setVolume(speedVolume);
            audio2.setPitch(speedPitch);
            speedChange = false;
        }

        // traction sound
        if (tractionBrakeControl.isTractionIntensityChange()) {
            ts = tractionBrakeControl.getTractionIntensity();

            audio1.setVolume((ts * 0.4f) + 0.03f);

            tractionBrakeControl.resetTractionIntensityChange();
        }

        // looping sounds - START and STOP
        if (loopingSoundStartStop) {
            loopingSoundStartStop = false;

            if (startAtcOverhastSound) {
                audioNode_atc_overhast.play();
                startAtcOverhastSound = false;
            }

            if (stopAtcOverhastSound) {
                audioNode_atc_overhast.stop();
                stopAtcOverhastSound = false;
            }

            if (startAtcAtcfeilSound) {
                audioNode_atc_atcfeil.play();
                startAtcAtcfeilSound = false;
            }

            if (stopAtcAtcfeilSound) {
                audioNode_atc_atcfeil.stop();
                stopAtcAtcfeilSound = false;
            }

            if (startAtcStartUpSound) {
                audioNode_atc_startup.play();
                startAtcStartUpSound = false;
            }

            if (stopAtcStartUpSound) {
                audioNode_atc_startup.stop();
                stopAtcStartUpSound = false;
            }

            if (startErtmsWarningSound) {
                audioNode_ertms_warning.play();
                startErtmsWarningSound = false;
            }

            if (stopErtmsWarningSound) {
                audioNode_ertms_warning.stop();
                stopErtmsWarningSound = false;
            }

            if (startErtmsContSound) {
                audioNode_ertms_cont.play();
                startErtmsContSound = false;
            }

            if (stopErtmsContSound) {
                audioNode_ertms_cont.stop();
                stopErtmsContSound = false;
            }
        }

        // non looping sounds - START
        if (nonLoopingSoundStart) {
            nonLoopingSoundStart = false;

            // switch sound
            if (playSwitchSound1) {
                audio3.play();
                playSwitchSound1 = false;
            }
            if (playSwitchSound2) {
                audio4.play();
                playSwitchSound2 = false;
            }
            // ATC
            if (playAtcKortSound) {
                audioNode_atc_kort.play();
                playAtcKortSound = false;
            }
            if (playAtc2KorteSound) {
                audioNode_atc_2korte.play();
                playAtc2KorteSound = false;
            }
            if (playAtcLangSound) {
                audioNode_atc_lang.play();
                playAtcLangSound = false;
            }
            if (playAtcBalisefeilSound) {
                audioNode_atc_balisefeil.play();
                playAtcBalisefeilSound = false;
            }
            if (playErtmsInfoSound) {
                audioNode_ertms_info.play();
                playErtmsInfoSound = false;
            }
            if (playErtmsClickSound) {
                audioNode_ertms_click.play();
                playErtmsClickSound = false;
            }
            if (playErtmsTooFastSound) {
                audioNode_ertms_tooFast.play();
                playErtmsTooFastSound = false;
            }
        }
    }

    private void soundsWhilePause() {
        if (startAtcStartUpSound) {
            audioNode_atc_startup.play();
            startAtcStartUpSound = false;
        }

        if (stopAtcStartUpSound) {
            audioNode_atc_startup.stop();
            stopAtcStartUpSound = false;
        }
    }

    public void activateAtcKortSound() {
        playAtcKortSound = true;
    }

    public void activateAtcLangSound() {
        playAtcLangSound = true;
    }

    public void activateAtc2KorteSound() {
        playAtc2KorteSound = true;
    }

    public void activateAtcBalisefeilSound() {
        playAtcBalisefeilSound = true;
    }

    public void activateAtcOverhastSound() {
        startAtcOverhastSound = true;
    }

    public void deActivateAtcOverhastSound() {
        stopAtcOverhastSound = true;
    }

    public void activateAtcfeilSound() {
        startAtcAtcfeilSound = true;
    }

    public void deActivateAtcfeilSound() {
        stopAtcAtcfeilSound = true;
    }

    public void activateAtcStartUpSound() {
        startAtcStartUpSound = true;
    }

    public void deActivateAtcStartUpSound() {
        stopAtcStartUpSound = true;
    }

    public void activateLoopingSoundStartStop() {
        loopingSoundStartStop = true;
    }

    public void activateNonLoopingSoundStart() {
        nonLoopingSoundStart = true;
    }

    public void activateErtmsInfoSound() {
        playErtmsInfoSound = true;
    }

    public void activateErtmsClickSound() {
        playErtmsClickSound = true;
    }

    public void activateErtmsTooFastSound() {
        playErtmsTooFastSound = true;
    }

    public void activateErtmsWarningSound() {
        startErtmsWarningSound = true;
    }

    public void deActivateErtmsWarningSound() {
        stopErtmsWarningSound = true;
    }

    public void activateErtmsContSound() {
        startErtmsContSound = true;
    }

    public void deActivateErtmsContSound() {
        stopErtmsContSound = true;
    }

    @Override
    public void passTCO(TrackConnectedObject tco) {
        super.passTCO(tco);

        if (spolingOn && !controlledSpolingOn) // leser ikke baliser osv under development spoling
        {
            return;                              // men leser under controllert spoling   
        }
        System.out.println("FRONTVEHICLE: pass something");
        if (tco instanceof Balise) {
            int x = ((Balise) tco).getX();
            int y = ((Balise) tco).getY();
            int z = ((Balise) tco).getZ();
            System.out.println("X: " + x + " Y: " + y + " Z: " + z);
            etcs.utforPassAtcBalise(((Balise) tco));
        } else if (tco instanceof EuroBalise) {
            System.out.println("EUROBALISE: " + tco.getPos() + " " + ((EuroBalise) tco).getLinePos());
            EuroBalise eb = ((EuroBalise) tco);
            etcs.utforErtmsBaliseOpKode(eb.getMessage(), eb.getLinePos(), eb.getDirection());
        } else if (tco instanceof ErtmsLevelAncmnt) {
            System.out.println("ERTMS LEVEL ANCMNT: " + tco.getPos() + " " + ((ErtmsLevelAncmnt) tco).getLinePos());
            ErtmsLevelAncmnt ela = ((ErtmsLevelAncmnt) tco);
            etcs.utforErtmsLevelAncmnte(ela);
        } else if (tco instanceof ErtmsStopp) {
            System.out.println("STOPPSKILT: " + tco.getPos());
            ErtmsStopp es = ((ErtmsStopp) tco);
            etcs.utforPassStoppSkilt(es);
        } else if (tco.getTypeIndex() == TrackConnectedObject.TYPE_INDEX_SOUNDTRIGGER_1) {
            playSwitchSound1 = true;
            nonLoopingSoundStart = true;
        } else if (tco.getTypeIndex() == TrackConnectedObject.TYPE_INDEX_SOUNDTRIGGER_2) {
            playSwitchSound2 = true;
            nonLoopingSoundStart = true;
        }
    }

    public void cabSwitchOperated(int cabNr, int state) {
        // atc
        if (state == ActivateCabSwitch.STATE_0) {
            rackFrame.getAtcSwitch().setState(false);
        }
        //

        etcs.setActivateCabState(cabNr, state);

        if (cabNr == 2) {
            setActiveTrackInfoReceiver(false, true);
            //direction = 1;
            tractionBrakeControl.setDriverCabinDirection(1);
        }
        if (cabNr == 1) {
            setActiveTrackInfoReceiver(true, false);
            //direction = -1;
            tractionBrakeControl.setDriverCabinDirection(-1);
        }
    }

    public void presetCabSwitch(int cabNr, int state) {
        this.activeCabNr = cabNr;
        tractionFrame.getActivateCabSwitchPanel().setState(state);
    }

    public void presetCabSwitchA(int cabNr) {
        presetCabSwitch(cabNr, ActivateCabSwitch.STATE_A);
    }

    @Override
    public ETCS getETCS() {
        return etcs;
    }

    public void oppdaterETCS_extern() {
        etcs.oppdaterETCS_extern();
    }

    // update control
    @Override
    public void update() {
        uc++;
        if (uc < 2) {
            return;
        }
        uc = 0;

        // hastighetsoppdatering
        tractionBrakeControl.update();
    }

    public Rack getRack() {
        return rack;
    }

    public RackFrame getRackFrame() {
        return rackFrame;
    }

    @Override
    protected void init3DVehicle(String ac3dFile) {
        super.init3DVehicle(ac3dFile);
        /*//Box box = new Box(3.5f/2,4.0f/2,24.0f/2);
    Spatial boxVehicle = loadModel(assetManager, "LokBase");
    Material mat = new Material( 
            assetManager, "Common/MatDefs/Misc/ShowNormals.j3md");
    //mat.setColor("Color", ColorRGBA.Gray);
    boxVehicle.setMaterial(mat);

    pivot.attachChild(boxVehicle);*/
        //

        // audio
        if (!StartParameters.audioOn) {
            return;
        }

        pivot.attachChild(initAudioTrac(assetManager));
        pivot.attachChild(initAudioDrive(assetManager));
        pivot.attachChild(initAudioSwitch1(assetManager));
        pivot.attachChild(initAudioSwitch2(assetManager));
        pivot.attachChild(initAudioAtcKort(assetManager));
        pivot.attachChild(initAudioAtc2Korte(assetManager));
        pivot.attachChild(initAudioAtcLang(assetManager));
        pivot.attachChild(initAudioAtcOverhast(assetManager));
        pivot.attachChild(initAudioAtcAtcfeil(assetManager));
        pivot.attachChild(initAudioAtcStartUp(assetManager));
        pivot.attachChild(initAudioAtcBalisefeil(assetManager));
        pivot.attachChild(initAudioErtmsInfo(assetManager));
        pivot.attachChild(initAudioErtmsClick(assetManager));
        pivot.attachChild(initAudioErtmsTooFast(assetManager));
        pivot.attachChild(initAudioErtmsWarning(assetManager));
        pivot.attachChild(initAudioErtmsCont(assetManager));
    }

    private MyAudioNode initAudioTrac(AssetManager assetManager) {
        audio1 = new MyAudioNode(assetManager, "Sounds/train/jevn_lav_75_5sek.wav", false);
        audio1.setPositional(false);
        audio1.setLooping(true);
        audio1.setVolume(0.03f);
        audio1.setPitch(1.0f);
        audio1.play();
        vehicleAudioList.add(audio1);
        return audio1;
    }

    private MyAudioNode initAudioDrive(AssetManager assetManager) {
        audio2 = new MyAudioNode(assetManager, "Sounds/train/jevn_lav_75_5sek_2.wav", false);
        audio2.setPositional(false);
        audio2.setLooping(true);
        audio2.setVolume(0.01f);
        audio2.setPitch(1.5f);
        audio2.play();
        vehicleAudioList.add(audio2);
        return audio2;
    }

    private MyAudioNode initAudioSwitch1(AssetManager assetManager) {
        audio3 = new MyAudioNode(assetManager, "Sounds/train/spv_metall_gnissing_12sek.wav", false);
        audio3.setPositional(false);
        audio3.setLooping(false);
        audio3.setVolume(0.4f);
        audio3.setPitch(1.0f);
        vehicleAudioList.add(audio3);
        return audio3;
    }

    private MyAudioNode initAudioSwitch2(AssetManager assetManager) {
        audio4 = new MyAudioNode(assetManager, "Sounds/train/dunk_lav_kj_7sek.wav", false);
        audio4.setPositional(false);
        audio4.setLooping(false);
        audio4.setVolume(0.4f);
        audio4.setPitch(1.0f);
        vehicleAudioList.add(audio4);
        return audio4;
    }

    private MyAudioNode initAudioAtcKort(AssetManager assetManager) {
        audioNode_atc_kort = new MyAudioNode(assetManager, "Sounds/etcs_stm/atc_kort.wav", false);
        audioNode_atc_kort.setPositional(false);
        audioNode_atc_kort.setLooping(false);
        audioNode_atc_kort.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_kort.setPitch(1.0f);
        vehicleAudioList.add(audioNode_atc_kort);
        return audioNode_atc_kort;
    }

    private MyAudioNode initAudioAtc2Korte(AssetManager assetManager) {
        audioNode_atc_2korte = new MyAudioNode(assetManager, "Sounds/etcs_stm/atc_2korte.wav", false);
        audioNode_atc_2korte.setPositional(false);
        audioNode_atc_2korte.setLooping(false);
        audioNode_atc_2korte.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_2korte.setPitch(1.0f);
        vehicleAudioList.add(audioNode_atc_2korte);
        return audioNode_atc_2korte;
    }

    private MyAudioNode initAudioAtcLang(AssetManager assetManager) {
        audioNode_atc_lang = new MyAudioNode(assetManager, "Sounds/etcs_stm/atc_lang.wav", false);
        audioNode_atc_lang.setPositional(false);
        audioNode_atc_lang.setLooping(false);
        audioNode_atc_lang.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_lang.setPitch(1.0f);
        vehicleAudioList.add(audioNode_atc_lang);
        return audioNode_atc_lang;
    }

    private MyAudioNode initAudioAtcOverhast(AssetManager assetManager) {
        audioNode_atc_overhast = new MyAudioNode(assetManager, "Sounds/etcs_stm/atc_overhast.wav", false);
        audioNode_atc_overhast.setPositional(false);
        audioNode_atc_overhast.setLooping(true);
        audioNode_atc_overhast.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_overhast.setPitch(1.0f);
        vehicleAudioList.add(audioNode_atc_overhast);
        return audioNode_atc_overhast;
    }

    private MyAudioNode initAudioAtcAtcfeil(AssetManager assetManager) {
        audioNode_atc_atcfeil = new MyAudioNode(assetManager, "Sounds/etcs_stm/atcfeil.wav", false);
        audioNode_atc_atcfeil.setName("atcfeil");
        audioNode_atc_atcfeil.setPositional(false);
        audioNode_atc_atcfeil.setLooping(true);
        audioNode_atc_atcfeil.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_atcfeil.setPitch(1.0f);
        vehicleAudioList.add(audioNode_atc_atcfeil);
        return audioNode_atc_atcfeil;
    }

    private MyAudioNode initAudioAtcStartUp(AssetManager assetManager) {
        audioNode_atc_startup = new MyAudioNode(assetManager, "Sounds/etcs_stm/atcfeil.wav", false);
        audioNode_atc_startup.setName("startup");
        audioNode_atc_startup.setPositional(false);
        audioNode_atc_startup.setLooping(true);
        audioNode_atc_startup.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_startup.setPitch(1.0f);
        audioNode_atc_startup.setPlayWhilePause(true);
        vehicleAudioList.add(audioNode_atc_startup);
        return audioNode_atc_startup;
    }

    private MyAudioNode initAudioAtcBalisefeil(AssetManager assetManager) {
        audioNode_atc_balisefeil = new MyAudioNode(assetManager, "Sounds/etcs_stm/balisefeil.wav", false);
        audioNode_atc_balisefeil.setPositional(false);
        audioNode_atc_balisefeil.setLooping(false);
        audioNode_atc_balisefeil.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_atc_balisefeil.setPitch(1.0f);
        vehicleAudioList.add(audioNode_atc_balisefeil);
        return audioNode_atc_balisefeil;
    }

    private MyAudioNode initAudioErtmsInfo(AssetManager assetManager) {
        audioNode_ertms_info = new MyAudioNode(assetManager, "Sounds/etcs_stm/S_info.wav", false);
        audioNode_ertms_info.setPositional(false);
        audioNode_ertms_info.setLooping(false);
        audioNode_ertms_info.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_ertms_info.setPitch(1.0f);
        vehicleAudioList.add(audioNode_ertms_info);
        return audioNode_ertms_info;
    }

    private MyAudioNode initAudioErtmsClick(AssetManager assetManager) {
        audioNode_ertms_click = new MyAudioNode(assetManager, "Sounds/etcs_stm/click.wav", false);
        audioNode_ertms_click.setPositional(false);
        audioNode_ertms_click.setLooping(false);
        audioNode_ertms_click.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_ertms_click.setPitch(1.0f);
        vehicleAudioList.add(audioNode_ertms_click);
        return audioNode_ertms_click;
    }

    private MyAudioNode initAudioErtmsTooFast(AssetManager assetManager) {
        audioNode_ertms_tooFast = new MyAudioNode(assetManager, "Sounds/etcs_stm/S1_toofast.wav", false);
        audioNode_ertms_tooFast.setPositional(false);
        audioNode_ertms_tooFast.setLooping(false);
        audioNode_ertms_tooFast.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_ertms_tooFast.setPitch(1.0f);
        vehicleAudioList.add(audioNode_ertms_tooFast);
        return audioNode_ertms_tooFast;
    }

    private MyAudioNode initAudioErtmsWarning(AssetManager assetManager) {
        audioNode_ertms_warning = new MyAudioNode(assetManager, "Sounds/etcs_stm/S2_warning.wav", false);
        audioNode_ertms_warning.setPositional(false);
        audioNode_ertms_warning.setLooping(false);
        audioNode_ertms_warning.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_ertms_warning.setPitch(1.0f);
        vehicleAudioList.add(audioNode_ertms_warning);
        return audioNode_ertms_warning;
    }

    private MyAudioNode initAudioErtmsCont(AssetManager assetManager) {
        audioNode_ertms_cont = new MyAudioNode(assetManager, "Sounds/etcs_stm/etcs_cont.wav", false);
        audioNode_ertms_cont.setPositional(false);
        audioNode_ertms_cont.setLooping(false);
        audioNode_ertms_cont.setVolume(ATC_SOUNDS_VOLUME);
        audioNode_ertms_cont.setPitch(1.0f);
        vehicleAudioList.add(audioNode_ertms_cont);
        return audioNode_ertms_cont;
    }

    @Override
    public void setSpeedKmh(float speedKmh) {
        super.setSpeedKmh(speedKmh);
        intSpeedKmh = (int) speedKmh;

        if (intSpeedKmh != intSpeedKmhPrev) {
            speedChange = true;
            speedChangeForSubClass = true;
        }

        intSpeedKmhPrev = intSpeedKmh;
    }

    public DMI getDMI1() {
        return dmi1;
    }

    public DMI getDMI2() {
        return dmi2;
    }

    public int getActiveCabNr() {
        return activeCabNr;
    }

    public void setActiveCabNr(int activeCabNr) {
        this.activeCabNr = activeCabNr;
    }

    public TractionFrame getTractionFrame() {
        return tractionFrame;
    }

    public AtcPanel getAtcPanel() {
        return atcPanel;
    }

    @Override
    public void setSpolingSpeedKmh(float spolingSpeedKmh) {
        if (activeCabNr == 2) {
            super.setSpolingSpeedKmh(spolingSpeedKmh);
        } else {
            super.setSpolingSpeedKmh(-spolingSpeedKmh);
        }
    }

    public void activateControlledSpoling() {
        controlledSpolingOn = true;
        setSpolingOn(true);
        setSpolingSpeedKmh(CONTROLLED_SPOLINGSPEED_KMH);
    }

    public void deActivateControlledSpoling() {
        controlledSpolingOn = false;
        setSpolingOn(false);
        setSpolingSpeedKmh(0);
    }

    public boolean isControlledSpolingOn() {
        return controlledSpolingOn;
    }

    public void activateContrReverseSpoling() {
        setSpolingOn(true);
        setSpolingSpeedKmh(CONTROLLED_SPOLING_REVERSE_SPEED_KMH);
    }

    public void deActivateContrReverseSpoling() {
        setSpolingOn(false);
        setSpolingSpeedKmh(0);
    }

    public boolean isVrModelExists() {
        return vrModelExists;
    }

    public VrAtcPanel getVrAtc() {
        return vrAtc;
    }

    public Spak getSpakB() {
        return spakB;
    }

    public Spak getSpakP() {
        return spakP;
    }

    public Vector3f getPersonOffsetVector() {
        return personOffsetVector;
    }

    public void setPersonOffsetVector(Vector3f personOffsetVector) {
        this.personOffsetVector = personOffsetVector;
    }

    public float getPersonRotationGrad() {
        return personRotationGrad;
    }

    public void setPersonRotationGrad(float personRotationGrad) {
        this.personRotationGrad = personRotationGrad;
    }

}
