/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vehicle;

import com.jme3.math.FastMath;

/**
 *
 * @author Eirik
 */
public class VehicleBrakeSystem 
{
    AirCoupling air1;
    AirCoupling air2;
    AirCoupling[] airCouplings;
    
    float reservePressure = 5;          //  0, ? - 5?
    float aChamberPressure = 5;         //  0, 3.5 - 5
    float aChamberReservePressure = 5;  //  0, 3.5? - 5?
    float brakePressure;                //  0, ? - ?
    
    float airFlowSpeed = 0.001f;        //  Value is not accurate
                                        //  Should be able to fill the vehicle from 0 after about 7 minutes
    
    VehicleBrakeSystem(AirCoupling air1, AirCoupling air2, boolean empty)
    {
        this.air1 = air1;
        this.air2 = air2;
        airCouplings = new AirCoupling[]{ air1, air2 };
        
        if (empty)
            emptyInstantly();
    }
    
    public void tick(float tpf)
    {
        for (int i=0; i<2; i++)
            checkAirValve(i, tpf);
        
        //  Check pressure difference in aChamber and its reserve to apply brakes
        if (aChamberPressure < aChamberReservePressure)
        {
            
        }
    }
    
    void checkAirValve(int i, float tpf)
    {
        boolean airOpen = airCouplings[i].getOpen();
        
        if (airOpen)
        {
            if (airCouplings[i].getConnectedTo() == null)
                aChamberPressure -= airFlowSpeed * tpf;
            else if (airCouplings[i].getConnectedTo().getOpen())
            {
                float hlPressure = airCouplings[i].getConnectedTo().getVehicle().getVehicleBrakeSystem().aChamberPressure;
                
                // Change pressure
                aChamberPressure += FastMath.sign(hlPressure - aChamberPressure) * airFlowSpeed * tpf;
            }
        }
    }
    
    public void emptyInstantly()
    {
        reservePressure = 0;
        aChamberPressure = 0; 
        aChamberReservePressure = 0; 
        brakePressure = 0; 
    }
}
